/**
 * Created by lanhao on 16/4/5.
 */

var App = function () {
    "use strict";
    this.plans = [];
    this.currentPlan = null;
    this.currentPlanName = null;
    this.currentApi = null;

    this.vueHeader = new Vue({
        el: '#header',
        data: {
            site:'JSOC.',
            version:'0.9.0',
            host:{},
            currentPlanName:'',
            plans: this.plans
        }
    });
    this.vueSider = new Vue({
        el:'#sider',
        data:{
            plan:{}
        }
    });
    this.vueDialog = new Vue({
        el:'#dialog',
        data:{
            role:''
        },
        methods:{
            close: function () {
                $('#dialog').hide();
            }
        }
    });

    this.dict = function (name) {
        var DIC = {
            'params':'URI Params',
            'query':'Query String'
        };
        return DIC[name]?DIC[name]:name;
    };
};

App.prototype.loadPlan = function (cb) {
    var _this = this;
    $.get('/index/plans', function (data) {
        if (data.code == 200) {
            _this.plans = data.data;
            cb && cb(null, null);
        } else {
            //todo
        }
    });
};

App.prototype.loadDetail = function (plan, cb) {
    var _this = this;
    if(app.currentPlanName==plan){
        _this.vueHeader._data.currentPlanName = _this.currentPlanName = plan;
        _this.vueHeader._data.host = _this.currentPlan;
        cb && cb(null,_this.currentPlan) ;
    }else {
        $.get('/index/detail?plan=' + plan, function (data) {
            if (data.code == 200) {
                _this.vueSider._data.plan = _this.currentPlan = data.data;
                _this.vueHeader._data.currentPlanName = _this.currentPlanName = plan;
                _this.vueHeader._data.host = _this.currentPlan;
                cb && cb(null, _this.currentPlan);
            } else {
                //todo
            }
        });
    }
};

App.prototype.apiCommon = function (api) {
    var _html = '';
    api = this.currentPlan.apis[api];
    _html += this.apiHead(api);
    _html += '<h1>REQUEST:</h1>';
    _html += this.apiObject(api.request.headers, 'request.headers');
    _html += this.apiObject(api.request.query, 'request.query');
    _html += this.apiObject(api.request.body, 'request.body');
    _html += '<h1>RESPONSE:</h1>';
    _html += this.apiObject(api.response.headers, 'response.headers');
    _html += this.apiObject(api.response.body, 'response.body');
    return _html;
};

App.prototype.apiHead = function (api) {
    var _html = '';
    _html += '<div><label>Name:</label><input role="name" class="apiHead" value="' + api.name + '"> ( API identify name )</div>';
    _html += '<div><label>METHOD:</label><input role="request.method" class="apiHead" placeholder="get / post / put / delete" value="' + api.request.method + '"> ( HTTP request method : [ get , post , put , delete ] )</div>';
    _html += '<div><label>URI:</label><input role="request.uri" class="apiHead" value="' + api.request.uri + '"> ( HTTP request URI )</div>';
    _html += this.apiObject(api.request.params,'request.params');
    return _html;
};


App.prototype.apiObject = function (obj, title) {
    var role = title;
    var _html = '<fieldSet role="'+title+'"><legend>' + this.dict(title.split('.').pop()) + '<span data-s=\''+role+'\' data-dialog="d_add_entity" class="am-icon-plus-square am-icon-fixed am-text-success">Add</span></legend>';
    for (var k in obj) {
        _html += this.apiEntity(k, obj[k],title);
    }
    return _html + '</fieldSet>';
};

App.prototype.apiEntity = function (key, entity,prefix,feedBack) {
    if(feedBack){
        var arr = prefix.split('.');
        arr.push(key);
        this.feedBack(arr,entity);
    }
    var _html = '';
    if (!((entity._assert!==undefined) || entity._length || entity._to || entity._from || entity._type)) {
        var role =prefix+'.'+key;
        _html += '<section class="entity" role="'+role+'"><label>' + key + ':</label><span data-s=\''+role+'\' data-dialog="d_add_entity" class="am-icon-plus-square am-icon-fixed am-text-success">Add</span>';
        for (var k in entity) {
            _html += this.apiEntity(k, entity[k],prefix+'.'+key);
        }
    } else {
        var role = prefix+'.'+key;
        _html += '<section class="entity"  role="'+role+'"><label>' + key + ':</label><span data-s=\''+role+'\' data-dialog="d_edit_entity" class="am-icon-edit am-icon-fixed am-text-primary">Edit</span><span class="am-icon-trash am-icon-fixed am-text-warning">Remove</span>';
        for (var k in entity) {
            if(k=='role')continue;
            _html += '<div class="option"><label>' + k + ':</label>' + '<span class="option-value">'+entity[k]+'</span></div>'
        }
    }
    return _html+'</section>';
};

App.prototype.dialog = function (caller,type, cb) {
    switch(type){
        case 'd_add_entity':
            var s = $(caller).data('s');
            this.vueDialog._data.role = s;
            var data = {name:'',data:{_assert:'',_choices:'',_from:'',_to:'',_length:'',_required:'off',_type:'',_new:true}};
            this.renderDialog(data);
            break;
        case 'd_edit_entity':
            var s = $(caller).data('s');
            this.vueDialog._data.role = s;
            var data = this.getData(s);
            data.data._new = false;

            this.renderDialog(data);
            break;
        default :
            break;
    }
    cb && cb(null,data);
};

App.prototype.renderDialog = function (data) {
    var _dialog = $('#dialog');
    _dialog.find('input[name=name]').val(data.name);
    for(var k in data.data){
        _dialog.find('input[name='+k+']').val(data.data[k]);
    }
};

App.prototype.feedBack = function (arr, data) {

    if(data._type && data._type=='Number' && data._assert){
        data._assert = 1 * data._assert;
    }
    var api = this.currentPlan.apis[this.currentApi];
    while(arr.length>1){
        var _k = arr.shift();
        if(!api[_k]){
            api[_k] = {};
        }
        api = api[_k];
    }
    api[arr[0]] = data;

};

App.prototype.getData = function (role) {
    var _a = role.split('.');
    var currentApi = app.currentPlan.apis[app.currentApi];
    var _k = '';
    var _data = currentApi;
    while(_a.length>0){
        _k = _a.shift();
        _data = _data[_k];
    }
    return {name:_k,data:_data};
};

!function ($) {

    var blink = function (sl) {
        $(sl).addClass('blink');
        setTimeout(function () {
            $(sl).removeClass('blink');
        }, 500);
    };

    var loading = {
        'delay': 300,
        'on': function () {
            $('#content>section').addClass('am-hide');
            $('#content>div').html('');
            $('#board').addClass('am-hide');
            $('#loading').removeClass('am-hide');
        },
        'off': function () {
            setTimeout(function () {
                $('#loading').addClass('am-hide');
                $('#board').removeClass('am-hide');
            }, loading.delay);
        }
    };

    $('#header').find('ul').get(0).addEventListener('click', function (e) {
        if ($(e.target).hasClass('plan')) {
            var plan = e.target.innerHTML;
            loading.on();
            window.app.loadDetail(plan, function (e, r) {
                loading.off();
            });
            $(this).parent().find('button').html(plan).click();
        }else{
            var key = prompt('请输入接口标识名(英文key)');
            if(/[a-z]+/.test(key)){
                app.plans.push(key);
                app.currentPlanName = key;
                app.vueSider._data.plan = app.currentPlan = {
                    host:'http://',
                    apis:{}
                };
                //app.vueHeader._data.host = app.currentPlan;
            }else{
                alert('请使用小写字母命名');
            }
        }
    });

    //侧边栏
    $('#sider').find('ul').get(0).addEventListener('click', function (e) {
        if (e.target.className == 'li-api') {
            $('#api').html('loading...');
            var api = e.target.dataset.api;
            app.currentApi = api;
            $('#content>section').removeClass('am-hide');
            $('#api').html(app.apiCommon(api));
        }else{
            var key = prompt('请输入接口标识名(英文key)');
            if(key && /[a-z]+/.test(key)){
                app.currentPlan.apis[key] = {
                    'name':key,
                    'request':{
                        'uri':'',
                        'method':'get',
                        'headers':{},
                        'query':{},
                        'body':{}
                    },
                    'response':{
                        'headers':{},
                        'body':{}
                    }
                };
                app.vueSider.plan = app.currentPlan;
                $(e.target).before('<li class="li-api" data-api="'+key+'"><i class="am-icon-chain am-icon-fw"></i>'+key+'</li>');
            }else{
                alert('请使用小写字母命名');
            }
        }
    });

    //竹主界面下所有 add edit 事件
    $('#api').get(0).addEventListener('click', function (e) {
        var dialog = e.target.dataset.dialog;
        if(dialog){
            $('#dialog').hide().css({
                top:(e.pageY-180)+'px',
                left:(e.pageX-120)+'px'
            });
            //根据 target 给dialog绑定数据（vue）
            app.dialog(e.target,dialog,function(e,r){
                //choices 清空
                $('#dialog_tags').tagsinput();
                $('#dialog_tags').tagsinput('removeAll');
                //choices 设置
                var _choices = r.data._choices?r.data._choices.split(','):[];
                if(_choices.length>0) {
                    for (var k in _choices) {
                        $('#dialog_tags').tagsinput('add', _choices[k]);
                    }
                }
                $('#dialog').find('button.am-dropdown-toggle').html(r.data._type?r.data._type:'<span class="am-icon-caret-down"></span>');
                $('#dialog').show();
            });
        }else if($(e.target).hasClass('am-text-warning')){
            var parent = $(e.target).parent();
            var role = parent.attr('role');
            var roleArr = role.split('.');
            var _p = app.currentPlan.apis[app.currentApi];
            while(roleArr.length>1){
                _p = _p[roleArr.shift()];
            }
            delete _p[roleArr[0]];
            parent.remove();
        }
    });

    //弹出层  数据类型选择
    $('#dialog').get(0).addEventListener('click', function (e) {
        if (e.target.localName == 'a') {
            var _text = $(e.target).text();
            $('input[name=_type]').val(_text);
            //if(_text == '父节点'){
            //    app.vueDialog._data.entity.entity = {};
            //
            //}else {
            //    var op = $(e.target).parent().parent().data('op');
            //    app.vueDialog._data.entity.entity[op] = _text;
            //}
            $(e.target).parent().parent().parent().find('button').html(_text).click();
        }
    });

    //弹出层保存
    $('#dialog_save_btn').click(function (e) {
        var data = {};
        var role = app.vueDialog.role;
        var inputs = $('#dialog').find('input.option');
        for(var i=0;i<inputs.length;i++){
            if(inputs[i].value=='')continue;
            data[inputs[i].name] = inputs[i].value;
            if(inputs[i].type == 'checkbox'){
                data[inputs[i].name] = inputs[i].checked;
            }
        }
        if(data._new == 'true'){
            role += '.'+data.name;
        }

        if(role && data.name){
            var _tmp = role.split('.');
            var key = _tmp.pop();
            var prefix = _tmp.join('.');
            delete data.name;
            if(data._new == 'true'){
                delete data._new;
                $('fieldset[role="' + prefix + '"],section[role="' + prefix + '"]').append(app.apiEntity(key, data, prefix, true));
            }else {
                delete data._new;
                $('section[role="' + role + '"]').prop('outerHTML', app.apiEntity(key, data, prefix, true));
            }
        }
        app.vueDialog.close();
    });

    //Save Run 功能按钮
    $('#content>section').find('button').click(function (e) {
        var cmd = $(e.target).attr('role');
        switch (cmd){
            case 'cmd_save':
                $.post('/index/savePlan',{
                    name:app.currentPlanName,
                    plan:JSON.stringify(app.currentPlan)
                }, function (data) {
                    console.log(data);
                },'json');
                break;
        }
    });


    $('#content>div').get(0).addEventListener('change', function (e) {
        if(e.target.className=='apiHead'){
            var role = $(e.target).attr('role').split('.');
            var value = $(e.target).val();
            var _target = app.currentPlan.apis[app.currentApi];
            while(role.length>1){
                _target = _target[role.shift()];
            }
            _target[role[0]] = value;
        }
    });

    // App start
    if(!window.app) {
        window.app = new App();
        app.loadPlan(function (e, r) {
            app.vueHeader._data.plans = app.plans;
            setTimeout(function () {
                $('#loading').addClass('am-hide');
                blink('#header .am-btn-fixed');
            }, 500);
        });
    }
}($);
